<template>
    <div class="component-upload-image">
        <el-upload
                multiple
                :action="FileUploadUrl"
                :on-success="handleUploadSuccess"
                :before-upload="handleBeforeUpload"
                :on-remove="handleDeleteFile"
                :limit="limit"
                :on-error="handleUploadError"
                :on-exceed="handleExceed"
                ref="fileUploads"
                :before-remove="handleDelete"
                :show-file-list="false"
                :headers="headers"
                :file-list="fileList"
                class="upload-file-uploader"
        >
            <el-button type="primary">选取word|pdf文件</el-button>
        </el-upload>
        <!-- 上传提示 -->
        <div class="el-upload__tip" v-if="showTip">
            请上传
            <template v-if="fileSize">
                大小不超过 <b style="color: #f56c6c">{{ fileSize }}MB</b>
            </template>
            <template v-if="fileType">
                格式为 <b style="color: #f56c6c">{{ fileType.join("/") }}</b>
            </template>
            的文件
        </div>
        <transition-group class="upload-file-list el-upload-list el-upload-list--text" name="el-fade-in-linear" tag="ul">
            <li :key="file.id" class="el-upload-list__item ele-upload-list__item-content" v-for="(file, index) in fileList">
                <el-link :href="`${baseUrl}${file.url}`" :underline="false" target="_blank">
                    <span class="el-icon-document">{{ getFileName(file.name) }}</span>
                </el-link>
                <div class="ele-upload-list__item-content-action">
                    <el-link :underline="false" @click="handleDeleteFile(file.path)" type="danger">删除</el-link>
                </div>
            </li>
        </transition-group>
    </div>
</template>

<script setup>
    import { getToken } from "@/utils/auth";
    import {delFile} from "../../api/VRdemo/FileUpload";
    import {Axios as axios} from "axios";
    const props = defineProps({
        modelValue: [String, Object, Array],

        // 文件数量限制
        limit: {
            type: Number,
            default: 1,
        },
        files: {
            type: Array,
            required: true
        },
        // 大小限制(MB)
        fileSize: {
            type: Number,
            default: 20,
        },
        // 文件类型, 例如["doc", "docx", "pdf"]
        fileType: {
            type: Array,
            default: () => ["doc", "xls", "ppt", "txt", "pdf",'png', 'jpg', 'jpeg'],
        },
        // 是否显示提示
        isShowTip: {
            type: Boolean,
            default: true
        },
    });


    const { proxy } = getCurrentInstance();
    const emit = defineEmits();
    const number = ref(0);
    const uploadList = ref([]);
    const dialogImageUrl = ref("");
    const dialogVisible = ref(false);
    const baseUrl = import.meta.env.VITE_APP_BASE_API;
    const FileUploadUrl = ref(import.meta.env.VITE_APP_BASE_API + "/VRdemo/file/upload"); // 上传的图片服务器地址
    const headers = ref({ Authorization: "Bearer " + getToken() });
    const fileList = ref([]);
    const showTip = computed(
        () => props.isShowTip && (props.fileType || props.fileSize)
    );

    watch(() => props.modelValue, val => {
        if (val) {
            // 首先将值转为数组
            const list = Array.isArray(val) ? val : props.modelValue.split(",");
            // 然后将数组转为对象数组
            fileList.value = list.map(item => {
                if (typeof item === "string") {
                    if (item.indexOf(baseUrl) === -1) {
                        item = { name: baseUrl + item, url: baseUrl + item };
                    } else {
                        item = { name: item, url: item };
                    }
                }
                return item;
            });
        } else {
            fileList.value = [];
            return [];
        }
    },{ deep: true, immediate: true });

    // 上传前loading加载
    function handleBeforeUpload(file) {
        let isFile = false;
        if (props.fileType.length) {
            let fileExtension = "";
            if (file.name.lastIndexOf(".") > -1) {
                fileExtension = file.name.slice(file.name.lastIndexOf(".") + 1);
            }
            isFile = props.fileType.some(type => {
                if (file.type.indexOf(type) > -1) return true;
                if (fileExtension && fileExtension.indexOf(type) > -1) return true;
                return false;
            });
        } else {
            isFile = file.type.indexOf("file") > -1;
        }
        if (!isFile) {
            proxy.$modal.msgError(
                `文件格式不正确, 请上传${props.fileType.join("/")}正确格式文件!`
            );
            return false;
        }
        if (props.fileSize) {
            const isLt = file.size / 1024 / 1024 < props.fileSize;
            if (!isLt) {
                proxy.$modal.msgError(`上传文件大小不能超过 ${props.fileSize} MB!`);
                return false;
            }
        }
        proxy.$modal.loading("正在上传，请稍候...");
        number.value++;
    }

    // 文件个数超出
    function handleExceed() {
        proxy.$modal.msgError(`上传文件数量不能超过 ${props.limit} 个!`);
    }

    // 上传成功回调
    function handleUploadSuccess(res, file) {
        if (res.code === 200) {
            uploadList.value.push({ name: res.fileName, url: res.fileName });
            uploadedSuccessfully();
        } else {
            number.value--;
            proxy.$modal.closeLoading();
            proxy.$modal.msgError(res.msg);
            proxy.$refs.imageUpload.handleRemove(file);
            uploadedSuccessfully();
        }
    }
    // 获取文件名称
    function getFileName(name) {
        if (name.lastIndexOf("/") > -1) {
            return name.slice(name.lastIndexOf("/") + 1);
        } else {
            return "";
        }
    }
    // // 删除文件
    // function handleDeletes(index) {
    //     const file = fileList.value[index];
    //     const fileId = file.fileid;
    //     fileList.value.splice(index, 1);
    //     delFile(fileId);
    //     emit("update:modelValue", listToString(fileList.value));
    // }

    async function handleDeleteFile(file, fileList) {
        fileList.push(file);
        const fileId = await delFile(file.fileid);
        if(fileId.obj){
            this.$message({type:'success',message:'删除成功!'});
            fileList.splice(file)
        }else{
            this.$message({type: 'error',message:'删除失败!'});
        }
        return fileList
    }
    // 上传结束处理
    function uploadedSuccessfully() {
        if (number.value > 0 && uploadList.value.length === number.value) {
            fileList.value = fileList.value.filter(f => f.url !== undefined).concat(uploadList.value);
            uploadList.value = [];
            number.value = 0;
            emit("update:modelValue", listToString(fileList.value));
            proxy.$modal.closeLoading();
        }
    }

    // 上传失败
    function handleUploadError() {
        proxy.$modal.msgError("上传图片失败");
        proxy.$modal.closeLoading();
    }

    // 对象转成指定字符串分隔
    function listToString(list, separator) {
        let strs = "";
        separator = separator || ",";
        for (let i in list) {
            if (undefined !== list[i].url && list[i].url.indexOf("blob:") !== 0) {
                strs += list[i].url.replace(baseUrl, "") + separator;
            }
        }
        return strs != "" ? strs.substr(0, strs.length - 1) : "";
    }

</script>

<style scoped lang="scss">
    // .el-upload--picture-card 控制加号部分
    :deep(.hide .el-upload--picture-card) {
        display: none;
    }
    .upload-file-list .ele-upload-list__item-content {
        display: flex;
        justify-content: space-between;
        align-items: center;
        color: inherit;
    }
    .ele-upload-list__item-content-action .el-link {
        margin-right: 10px;
    }
    .upload-file-list .el-upload-list__item {
        border: 1px solid #e4e7ed;
        line-height: 2;
        margin-bottom: 10px;
        position: relative;
    }
</style>